<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-container id="dashboard" fluid tag="section">
    <v-row>
      <v-col
        cols="12"
        sm="6"
        md="4"
        v-if="recipes.length == 0"
      >
        <v-sheet
          :color="`grey lighten-3`"
          height="300px"
          class="pa-3"
        >
          <v-skeleton-loader
            class="mx-auto"
            max-width="400"
            type="card"
          ></v-skeleton-loader>
        </v-sheet>
      </v-col>
      <v-col
        cols="12"
        sm="6"
        md="4"
        v-if="recipes.length == 0"
      >
        <v-sheet
          :color="`grey lighten-3`"
          height="300px"
          class="pa-3"
        >
          <v-skeleton-loader
            class="mx-auto"
            max-width="400"
            type="card"
          ></v-skeleton-loader>
        </v-sheet>
      </v-col>
      <v-col
        cols="12"
        sm="6"
        md="4"
        v-if="recipes.length == 0"
      >
        <v-sheet
          :color="`grey lighten-3`"
          height="300px"
          class="pa-3"
        >
          <v-skeleton-loader
            class="mx-auto"
            max-width="400"
            type="card"
          ></v-skeleton-loader>
        </v-sheet>
      </v-col>
      <v-col
        cols="12"
        sm="6"
        md="4"
        v-for="(recipe, i) in recipes"
        :key="`sub-group-${i}`"
        @click="recipeClicked(recipe)"
        class="recipes"
      >
        
        <v-card
          class="mx-auto"
          max-width="400"
        >
          <v-img
            class="white--text align-end"
            height="300px"
            :src="recipe.photo_url"
          >
            <v-card-title class="recipe-title">{{recipe.title}}</v-card-title>
          </v-img>          
        </v-card>
      </v-col>
    </v-row>
    <v-dialog
      v-model="dialog"
      max-width="850px"
    >      
      <v-card>
        <v-card-title>
          <span>{{ current_recipe.title }}</span>
        </v-card-title>

        <v-card-text>
          <v-container>
            <v-row>
              <v-parallax
                :src="current_recipe.photo_url"
                max-height="200px"
                class="dialog-image"
              ></v-parallax>
              <v-progress-circular
                indeterminate
                color="primary"
                v-if="loading"
              ></v-progress-circular>
              <v-chip class="mt-2" v-for="(tag, i) in current_recipe.tags" :key="i">{{tag.name}}</v-chip>
              <h3 class="mt-2" style="width: 100%;" v-if="!!current_recipe.chef_name">{{"Chef: " + current_recipe.chef_name}}</h3>
              <h4 class="mt-2">{{current_recipe.description}}</h4>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>          
          <v-btn
            text
            @click="close"
          >
            Close
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
  import { mapState, mapActions } from 'vuex'
  import Chart from 'chart.js';
  import moment from 'moment';
  export default {
  name: "Dashboard",

  data() {
    return {
      page: 1,
      per_page: 10,
      order_by: "",
      dialog: false,
      current_recipe: {}
    };
  },
  computed: {
    ...mapState({
      recipes: state => state.recipe.recipes,
      paginateOptions: state => state.recipe.paginateOptions,
      recipesSize: state => state.recipe.recipesSize,
    }),
  },
  created() {         
    this.fetchRecipes()
  },
  methods: {
    recipeClicked(recipe) {
      console.log(recipe)
      this.dialog = true
      this.current_recipe = recipe
      this.loading = true
      this.findRecipe(recipe.id)
    },
    close() {
      this.dialog = false
    },
    fetchRecipes() {
      let generatedRoute = ''
      generatedRoute += '?page=' + this.page
      generatedRoute += '&per_page=' + this.per_page
      if(this.order_by != "")
        generatedRoute += '&order_by=' + this.order_by

      this.$store.dispatch('recipe/getAllRecipes',
      {
        params: generatedRoute,
        cb: (resp)=>{
          if(resp.result === 'OK'){
            console.log(this.recipes)
          }
          this.loading = false
        }
      })
    },
    findRecipe(recipe_id) {
      this.$store.dispatch('recipe/findRecipe',
      {
        recipe_id,
        cb: (resp)=>{
          if(resp.result === 'OK'){
            this.current_recipe = this.recipes.find(recipe=>recipe.id == this.current_recipe.id)
          }
          this.loading = false
        }
      })
    }
  },
};
</script>

<style scoped>
    .chart {
      height: "80%";
      width: "100%";
    }
    .map {
        width: 60%;
        height: 600px;
    }
    .recipe-title {
      background-color: rgba(199,199,199,0.4);
      font-size: 20px !important;
    }
    .recipes:hover {
      webkit-filter: blur(2px); /* Chrome, Safari, Opera */
      filter: blur(2px);
      cursor: pointer;
    }
    .dialog-image {
      border-radius: 10px;
      height: 200px !important;
      width: 100%;
    }
</style>

